<?php
namespace Teknisa\PLA\Modules\Consumo\Controllers;

use Zeedhi\Framework\DTO;
use \Setforms2\Shared\ORM\DateTime;
use Zeedhi\Framework\DTO\Response\Error;

class Pla00800 extends \Zeedhi\Framework\Controller\Report {

    protected $Pla00800PrevisaoDeConsumoController;
    protected $reportService;
    protected $environment;
    protected $qr2Strategy;
    protected $birtStrategy;
    protected $libUtilities;
    protected $reportMapping = array (
        'pla00800' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'       => 'P_DTPERIINI',
                'DTPERIFIN'       => 'P_DTPERIFIN',
                'PRODINI'         => 'P_PRODINI',
                'PRODFIN'         => 'P_PRODFIN',
                'NMPRODINI'       => 'P_NMPRODINI',
                'NMPRODFIN'       => 'P_NMPRODFIN',
                'TIPONIVEL'       => 'P_TIPONIVEL',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'ORDENA'          => 'P_ORDENA',
                'IMPRIME_F'       => 'P_IMPRIME_F',
                'IMPRIME_S'       => 'P_IMPRIME_S',
                'STARREDONDA'     => 'P_STARREDONDA',
                'IDSERVICO'       => 'P_IDSERVICO',
                'ACRESCIMO'       => 'P_ACRECIMO',
                'TAMACNIVEL'      => 'P_TAMACNIVEL',
                'TAMCODIGO'       => 'P_TAMCODIGO',
                'NRTIPOCUST'      => 'P_NRTIPOCUST',
                'L_FILIAL1'       => 'L_FILIAL1',
                'SERVICO1'        => 'P_SERVICO1',
                'IDSUBGRUP'       => 'P_IDSUBGRUP',
                'DTINICIAL'       => 'P_DTINICIAL',
                'DTFINAL'         => 'P_DTFINAL',
                'CDPRODINI'       => 'P_CDPRODINI',
                'CDPRODFIN'       => 'P_CDPRODFIN',
                'L_FILIAL2'       => 'L_FILIAL2',
                'SERVICO2'        => 'P_SERVICO2',
                'CDGRUPPROD'      => 'P_CDGRUPPROD',
                'LISTASUBGRUP'    => 'P_LISTASUBGRUP',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'NRORG'           => 'P_NRORG'
            ),
        ),
        
        'pla00801' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'       => 'P_DTPERIINI',
                'DTPERIFIN'       => 'P_DTPERIFIN',
                'PRODINI'         => 'P_PRODINI',
                'PRODFIN'         => 'P_PRODFIN',
                'NMPRODINI'       => 'P_NMPRODINI',
                'NMPRODFIN'       => 'P_NMPRODFIN',
                'TIPONIVEL'       => 'P_TIPONIVEL',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'ORDENA'          => 'P_ORDENA',
                'IMPRIME_F'       => 'P_IMPRIME_F',
                'IMPRIME_S'       => 'P_IMPRIME_S',
                'STARREDONDA'     => 'P_STARREDONDA',
                'IDSERVICO'       => 'P_IDSERVICO',
                'ACRESCIMO'       => 'P_ACRECIMO',
                'TAMACNIVEL'      => 'P_TAMACNIVEL',
                'TAMCODIGO'       => 'P_TAMCODIGO',
                'NRTIPOCUST'      => 'P_NRTIPOCUST',
                'L_FILIAL1'       => 'L_FILIAL1',
                'SERVICO1'        => 'P_SERVICO1',
                'IDSUBGRUP'       => 'P_IDSUBGRUP',
                'DTINICIAL'       => 'P_DTINICIAL',
                'DTFINAL'         => 'P_DTFINAL',
                'CDPRODINI'       => 'P_CDPRODINI',
                'CDPRODFIN'       => 'P_CDPRODFIN',
                'L_FILIAL2'       => 'L_FILIAL2',
                'SERVICO2'        => 'P_SERVICO2',
                'CDGRUPPROD'      => 'P_CDGRUPPROD',
                'LISTASUBGRUP'    => 'P_LISTASUBGRUP',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'NRORG'           => 'P_NRORG'
            ),
        ),

        'pla00802' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI'       => 'P_DTPERIINI',
                'CDGRUPPROD'      => 'P_CDGRUPPROD',
                'PRODINI'         => 'P_PRODINI',
                'NMPRODINI'       => 'P_NMPRODINI',
                'NMPRODFIN'       => 'P_NMPRODFIN',
                'TAMACNIVEL'      => 'P_TAMACNIVEL',
                'STARREDONDA'     => 'P_STARREDONDA',
                'IMPRIME_S'       => 'P_IMPRIME_S',
                'L_FILIAL1'       => 'L_FILIAL1',
                'SERVICO'         => 'P_SERVICO',
                'SERVICO1'        => 'P_SERVICO1',
                'SERVICO2'        => 'P_SERVICO2',
                'DTFINAL'         => 'P_DTFINAL',
                'DTPERIFIN'       => 'P_DTPERIFIN',
                'ACRESCIMO'       => 'P_ACRECIMO',
                'IDSUBGRUP'       => 'P_IDSUBGRUP',
                'LISTASUBGRUP'    => 'P_LISTASUBGRUP',
                'CDFILCENTCMP'    => 'P_CDFILCENTCMP',
                'PRODFIN'         => 'P_PRODFIN',
                'TAMCODIGO'       => 'P_TAMCODIGO',
                'ORDENA'          => 'P_ORDENA',
                'IDSERVICO'       => 'P_IDSERVICO',
                'CDPRODINI'       => 'P_CDPRODINI',
                'CDPRODFIN'       => 'P_CDPRODFIN',
                'IMPRIME_F'       => 'P_IMPRIME_F',
                'L_FILIAL2'       => 'L_FILIAL2',
                'DTINICIAL'       => 'P_DTINICIAL',
                'TIPONIVEL'       => 'P_TIPONIVEL',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'NRTIPOCUST'      => 'P_NRTIPOCUST',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'NRORG'           => 'P_NRORG'
            ),
        ),

        'pla00804' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'DTPERIINI' => 'P_DTPERIINI',
                'CDGRUPPROD' => 'P_CDGRUPPROD',
                'NMPRODFIN' => 'P_NMPRODFIN',
                'TAMACNIVEL' => 'P_TAMACNIVEL',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'SERVICO1' => 'P_SERVICO1',
                'SERVICO2' => 'P_SERVICO2',
                'SERVICO'  => 'P_SERVICO',
                'ACRESCIMO' => 'P_ACRECIMO',
                'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                'TAMCODIGO' => 'P_TAMCODIGO',
                'CDPRODFIN' => 'P_CDPRODFIN',
                'PRODINI' => 'P_PRODINI',
                'NMPRODINI' => 'P_NMPRODINI',
                'STARREDONDA' => 'P_STARREDONDA',
                'IMPRIME_S' => 'P_IMPRIME_S',
                'L_FILIAL1' => 'L_FILIAL1',
                'DTFINAL' => 'P_DTFINAL',
                'DTPERIFIN' => 'P_DTPERIFIN',
                'IDSUBGRUP' => 'P_IDSUBGRUP',
                'LISTASUBGRUP' => 'P_LISTASUBGRUP',
                'PRODFIN' => 'P_PRODFIN',
                'TIPONIVEL' => 'P_TIPONIVEL',
                'IMPRIME_F' => 'P_IMPRIME_F',
                'IDSERVICO' => 'P_IDSERVICO',
                'L_FILIAL2' => 'L_FILIAL2',
                'DTINICIAL' => 'P_DTINICIAL',
                'CDPRODINI' => 'P_CDPRODINI',
                'LISTAFILI' => 'P_CDFILIAL',
                'ORDENA' => 'P_ORDENA',
                'NRTIPOCUST' => 'P_NRTIPOCUST',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'NRORG'      => 'P_NRORG'
            ),
        ),

        'pla00805' =>
        array (
            'strategy' => 'QR2',
            'parameterMapping' =>
            array (
                'DTPERIINI' => 'P_DTPERIINI',
                'NMPRODINI' => 'P_NMPRODINI',
                'NMPRODFIN' => 'P_NMPRODFIN',
                'STARREDONDA' => 'P_STARREDONDA',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'L_FILIAL1' => 'L_FILIAL1',
                'SERVICO1' => 'P_SERVICO1',
                'SERVICO'  => 'P_SERVICO',
                'DTFINAL' => 'P_DTFINAL',
                'IDSUBGRUP' => 'P_IDSUBGRUP',
                'PRODFIN' => 'P_PRODFIN',
                'ORDENA' => 'P_ORDENA',
                'L_FILIAL2' => 'L_FILIAL2',
                'DTINICIAL' => 'P_DTINICIAL',
                'LISTAFILI' => 'P_CDFILIAL',
                'CDGRUPPROD' => 'P_CDGRUPPROD',
                'PRODINI' => 'P_PRODINI',
                'IMPRIME_S' => 'P_IMPRIME_S',
                'SERVICO2' => 'P_SERVICO2',
                'DTPERIFIN' => 'P_DTPERIFIN',
                'ACRESCIMO' => 'P_ACRECIMO',
                'LISTASUBGRUP' => 'P_LISTASUBGRUP',
                'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                'TIPONIVEL' => 'P_TIPONIVEL',
                'TAMCODIGO' => 'P_TAMCODIGO',
                'IMPRIME_F' => 'P_IMPRIME_F',
                'IDSERVICO' => 'P_IDSERVICO',
                'CDPRODINI' => 'P_CDPRODINI',
                'CDPRODFIN' => 'P_CDPRODFIN',
                'TAMACNIVEL' => 'P_TAMACNIVEL',
                'CDSERVICO' => 'P_CDSERVICO',
                'NRTIPOCUST' => 'P_NRTIPOCUST',
            ),
        ),

        'pla00806' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'SERVICO'  => 'P_SERVICO',
                'STARREDONDA' => 'P_STARREDONDA',
                'DTPERIINI' => 'P_DTPERIINI',
                'CDGRUPFILI' => 'P_CDGRUPFILI',
                'NMPRODFIN' => 'P_NMPRODFIN',
                'IMPRIME_S' => 'P_IMPRIME_S',
                'DTFINAL' => 'P_DTFINAL',
                'ACRESCIMO' => 'P_ACRECIMO',
                'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                'PRODFIN' => 'P_PRODFIN',
                'TIPONIVEL' => 'P_TIPONIVEL',
                'ORDENA' => 'P_ORDENA',
                'IMPRIME_F' => 'P_IMPRIME_F',
                'DTINICIAL' => 'P_DTINICIAL',
                'CDPRODINI' => 'P_CDPRODINI',
                'PRODINI' => 'P_PRODINI',
                'NMPRODINI' => 'P_NMPRODINI',
                'TAMACNIVEL' => 'P_TAMACNIVEL',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'DTPERIFIN' => 'P_DTPERIFIN',
                'IDSUBGRUP' => 'P_IDSUBGRUP',
                'LISTASUBGRUP' => 'P_LISTASUBGRUP',
                'TAMCODIGO' => 'P_TAMCODIGO',
                'CDGRUPPROD' => 'P_CDGRUPPROD',
                'NMGRUPFILI'   => 'P_NMGRUPFILI',
                'CDPRODFIN' => 'P_CDPRODFIN',
                'LISTACONSPLAN' => 'P_LISTACONSPLAN',
                'NRTIPOCUST' => 'P_NRTIPOCUST',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'NRORG' => 'P_NRORG'
            ),
        ),

        'pla00807' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'SERVICO'  => 'P_SERVICO',
                'DTPERIINI' => 'P_DTPERIINI',
                'NMPRODINI' => 'P_NMPRODINI',
                'STARREDONDA' => 'P_STARREDONDA',
                'IMPRIME_S' => 'P_IMPRIME_S',
                'TAMCODIGO' => 'P_TAMCODIGO',
                'CDPRODINI' => 'P_CDPRODINI',
                'CDPRODFIN' => 'P_CDPRODFIN',
                'CDGRUPPROD' => 'P_CDGRUPPROD',
                'PRODINI' => 'P_PRODINI',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'DTFINAL' => 'P_DTFINAL',
                'DTPERIFIN' => 'P_DTPERIFIN',
                'ACRESCIMO' => 'P_ACRECIMO',
                'IDSUBGRUP' => 'P_IDSUBGRUP',
                'LISTASUBGRUP' => 'P_LISTASUBGRUP',
                'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                'PRODFIN' => 'P_PRODFIN',
                'ORDENA' => 'P_ORDENA',
                'IMPRIME_F' => 'P_IMPRIME_F',
                'DTINICIAL' => 'P_DTINICIAL',
                'CDGRUPFILI' => 'P_CDGRUPFILI',
                'NMGRUPFILI'   => 'P_NMGRUPFILI',
                'CDSERVICO' => 'P_CDSERVICO',
                'LISTACONSPLAN' => 'P_LISTACONSPLAN',
                'NMPRODFIN' => 'P_NMPRODFIN',
                'NRTIPOCUST' => 'P_NRTIPOCUST',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'NRORG' => 'P_NRORG'
            ),
        ),

        'pla00809' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'SERVICO'      => 'P_SERVICO',
                'SERVICO2'     => 'P_SERVICO2',
                'DTFINAL'      => 'P_DTFINAL',
                'DTPERIFIN'    => 'P_DTPERIFIN',
                'ACRESCIMO'    => 'P_ACRECIMO',
                'IDSUBGRUP'    => 'P_IDSUBGRUP',
                'LISTASUBGRUP' => 'P_LISTASUBGRUP',
                'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                'PRODFIN'      => 'P_PRODFIN',
                'TIPONIVEL'    => 'P_TIPONIVEL',
                'TAMCODIGO'    => 'P_TAMCODIGO',
                'ORDENA'       => 'P_ORDENA',
                'IMPRIME_F'    => 'P_IMPRIME_F',
                'IDSERVICO'    => 'P_IDSERVICO',
                'L_FILIAL2'    => 'L_FILIAL2',
                'DTINICIAL'    => 'P_DTINICIAL',
                'CDPRODINI'    => 'P_CDPRODINI',
                'CDPRODFIN'    => 'P_CDPRODFIN',
                'DTPERIINI'    => 'P_DTPERIINI',
                'CDGRUPPROD'   => 'P_CDGRUPPROD',
                'PRODINI'      => 'P_PRODINI',
                'NMPRODINI'    => 'P_NMPRODINI',
                'NMPRODFIN'    => 'P_NMPRODFIN',
                'STARREDONDA'  => 'P_STARREDONDA',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'IMPRIME_S'    => 'P_IMPRIME_S',
                'L_FILIAL1'    => 'L_FILIAL1',
                'CDGRUPFILI'   => 'P_CDGRUPFILI',
                'NMGRUPFILI'   => 'P_NMGRUPFILI',
                'TAMACNIVEL'   => 'P_TAMACNIVEL',
                'SERVICO1'     => 'P_SERVICO1',
                'NRTIPOCUST'   => 'P_NRTIPOCUST',
                'CDPICTPROD'   => 'P_CDPICTPROD',
                'NRORG'        => 'P_NRORG'
            ),
        ),

        'pla00803' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'SERVICO'  => 'P_SERVICO',
                'DTPERIINI' => 'P_DTPERIINI',
                'CDGRUPPROD' => 'P_CDGRUPPROD',
                'PRODINI' => 'P_PRODINI',
                'NMPRODINI' => 'P_NMPRODINI',
                'STARREDONDA' => 'P_STARREDONDA',
                'DTPERIFIN' => 'P_DTPERIFIN',
                'IDSUBGRUP' => 'P_IDSUBGRUP',
                'LISTASUBGRUP' => 'P_LISTASUBGRUP',
                'PRODFIN' => 'P_PRODFIN',
                'TAMCODIGO' => 'P_TAMCODIGO',
                'IMPRIME_F' => 'P_IMPRIME_F',
                'IDSERVICO' => 'P_IDSERVICO',
                'NMPRODFIN' => 'P_NMPRODFIN',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'IMPRIME_S' => 'P_IMPRIME_S',
                'SERVICO1' => 'P_SERVICO1',
                'DTFINAL' => 'P_DTFINAL',
                'ACRESCIMO' => 'P_ACRECIMO',
                'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                'TIPONIVEL' => 'P_TIPONIVEL',
                'L_FILIAL2' => 'L_FILIAL2',
                'DTINICIAL' => 'P_DTINICIAL',
                'CDPRODINI' => 'P_CDPRODINI',
                'CDPRODFIN' => 'P_CDPRODFIN',
                'LISTAFILI' => 'P_CDFILIAL',
                'TAMACNIVEL' => 'P_TAMACNIVEL',
                'L_FILIAL1' => 'L_FILIAL1',
                'ORDENA' => 'P_ORDENA',
                'SERVICO2' => 'P_SERVICO2',
                'NRTIPOCUST' => 'P_NRTIPOCUST',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'NRORG'     =>  'P_NRORG'
            ),
        ),

        'pla00808' =>
        array (
            'strategy' => 'BIRT',
            'parameterMapping' =>
            array (
                'PRODINI' => 'P_PRODINI',
                'STARREDONDA' => 'P_STARREDONDA',
                'IMPRIME_S' => 'P_IMPRIME_S',
                'DTPERIFIN' => 'P_DTPERIFIN',
                'ACRESCIMO' => 'P_ACRECIMO',
                'CDGRUPPROD' => 'P_CDGRUPPROD',
                'NMPRODINI' => 'P_NMPRODINI',
                'NMPRODFIN' => 'P_NMPRODFIN',
                'TAMACNIVEL' => 'P_TAMACNIVEL',
                'TIPOCUSTO_LABEL' => 'P_TIPOCUSTO',
                'IDSUBGRUP' => 'P_IDSUBGRUP',
                'LISTASUBGRUP' => 'P_LISTASUBGRUP',
                'CDFILCENTCMP' => 'P_CDFILCENTCMP',
                'PRODFIN' => 'P_PRODFIN',
                'TIPONIVEL' => 'P_TIPONIVEL',
                'TAMCODIGO' => 'P_TAMCODIGO',
                'ORDENA' => 'P_ORDENA',
                'IMPRIME_F' => 'P_IMPRIME_F',
                'IDSERVICO' => 'P_IDSERVICO',
                'LISTACONSPLAN' => 'P_LISTACONSPLAN',
                'NRTIPOCUST' => 'P_NRTIPOCUST',
                'DTPERIINI' => 'P_DTPERIINI',
                'CDPICTPROD'      => 'P_CDPICTPROD',
                'CDPICTPRAT'      => 'P_CDPICTPRAT',
                'NRORG' => 'P_NRORG'
            ),
        ),
    );
    
    public function __construct($Pla00800PrevisaoDeConsumoController, $reportService, $environment, $qr2Strategy, $birtStrategy,$libUtilities) {
        $this->Pla00800PrevisaoDeConsumoController = $Pla00800PrevisaoDeConsumoController;
        $this->reportService = $reportService;
        $this->environment  = $environment;
        $this->qr2Strategy   = $qr2Strategy;
        $this->birtStrategy  = $birtStrategy;
        $this->libUtilities  = $libUtilities;
        parent::__construct($reportService);
    }
    
    

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {

        try {
            ini_set('max_execution_time',500);
            $row = $request->getRow();
            $row['NRORG'] = $this->environment->getNrOrg();
           
            if($row['__report_name'] == "pla00800" || $row['__report_name'] == "pla00801" || $row['__report_name'] == "pla00802" || $row['__report_name'] == "pla00803"|| $row['__report_name'] == "pla00804"|| $row['__report_name'] == "pla00809"){
                $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
                $row['L_FILIAL1'] = $this->Pla00800PrevisaoDeConsumoController->setFilialLista($row, 'L_FILIAL1');
                $row['L_FILIAL2'] = $row['L_FILIAL1'];
            }else if($row['__report_name'] == "pla00806" || $row['__report_name'] == "pla00807" || $row['__report_name'] == "pla00808"  ){
                $this->birtStrategy->setReportFormat(strtolower($row['QR2TYPE']));
                $row['L_FILIAL1'] = $this->Pla00800PrevisaoDeConsumoController->setFilial($row, 'L_FILIAL1');
            }else{
                $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
                $row['L_FILIAL1'] = $this->Pla00800PrevisaoDeConsumoController->setFilial($row, 'L_FILIAL1');
                $row['L_FILIAL2'] = $row['L_FILIAL1'];
                $row['LISTAFILI'] = $row['L_FILIAL1'];
            }
            $row = $this->Pla00800PrevisaoDeConsumoController->setDatas($row);
            
            
            //array com as filiais selecionadas
            $arrayFiliais = array();
            $arrayFiliais=array_column($row['CDLISTA'], "CDLISTA");
            //coleta de dados
             $this->libUtilities->saveCollectedData($arrayFiliais,'PREVISAO_CONSUMO');
             
             
            $row['SERVICO1'] = $this->Pla00800PrevisaoDeConsumoController->setServico($row, 'SERVICO1');
            $row['SERVICO2'] = $row['SERVICO1'];
            
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), 1));
        }
    }
}