<?php
namespace Teknisa\PLA\Modules\Prato\Controllers;

use Zeedhi\Framework\DataSource\DataSet;

class EmbalagensParaProduto extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = 'embalagensparaproduto';
    protected $parameterBagColumns = array(
        'CDPRODUTOI', 'CDPRODUTOF', 'CDCONTAINER', 'NRORG'
    );

    protected $environment;
    protected $conection;

    public function __construct(
        $crudService, $parameterBag, $dataSourceManager,
        \Teknisa\GER\Utilities\Environment $environment,
		$conection
    ) {
        parent::__construct($crudService, $parameterBag);
        $this->dataSourceManager = $dataSourceManager;
        $this->environment = $environment;
        $this->conection = $conection;
    }

    public function salvaRelacaoProdEmbal(
        \Zeedhi\Framework\DTO\Request\Row $request,
        \Zeedhi\Framework\DTO\Response $response
    ){
        $this->conection->beginTransaction();
        try {
            $rows = $request->getRow();

            foreach ($rows as $row) {
                $produto = $row['CDPRODUTO'];
                $container = $row['CDCONTAINER'];

                $filterCriteria
                    = new \Zeedhi\Framework\DataSource\FilterCriteria(
                    'embalagemporproduto'
                );
                $filterCriteria->addCondition('CDPRODUTO', $produto);
                $filterCriteria->addCondition('CDCONTAINER', $container);
                $filterCriteria->addCondition(
                    'NRORG', $this->environment->getNrOrgTrab()
                );

                $dataSet = $this->dataSourceManager->findBy($filterCriteria);
                $relacao = $dataSet->getRows();

                if (count($relacao) > 0) {
                    $dados = array(
                        'NRORG' => $this->environment->getNrOrgTrab(),
                        '__is_new' => false,
                        'CDPRODUTO' => $produto,
                        'CDCONTAINER' => $container,
                        'VRQTDEPRODEMB' => str_replace(',', '.', str_replace('.', '',$row['QTCONTAINER']))
                    );
                } else {
                    $dados = array(
                        'NRORG' => $this->environment->getNrOrgTrab(),
                        '__is_new' => true,
                        'CDPRODUTO' => $produto,
                        'CDCONTAINER' => $container,
                        'VRQTDEPRODEMB' => str_replace(',', '.', str_replace('.', '',$row['QTCONTAINER']))
                    );
                }

                $requestInser = new \Zeedhi\Framework\DTO\Request\Row(
                    $dados, '', '', ''
                );
                $dadosInserir = $this->crudService->getRowsToSave(
                    $requestInser, "relprodemb"
                );

                $this->crudService->save("relprodemb", $dadosInserir);
            }

            $this->conection->commit();
            $response->addDataset(new DataSet('RETORNO', array(true)));
        } catch (\Exception $e) {
            $this->conection->rollback();
            $response->setError(new \Zeedhi\Framework\DTO\Response\Error($e->getMessage(), 1));
        }
    }


}