<?php
namespace Teknisa\PLA\Modules\Relatorio\Controllers;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Pla04800AnaliseProduzidoXVendidoXSobra extends \Zeedhi\Framework\Controller\Report {

	protected $reportService;
	protected $crudService;
	protected $parameterBagColumns;
	protected $dataSourceManager;

	public function __construct($reportService, $crudService, $dataSourceManager) {

		$this->reportService       		= $reportService;
		$this->crudService         		= $crudService;
		$this->dataSourceManager 		  = $dataSourceManager;
	}

	protected $reportMapping = array (
		'PLA04800' =>
		array (
			'strategy' => 'QR2',
			'parameterMapping' =>
			array (
				"CDFILIAL"			=>"P_CDFILIAL",
			  "NMSERVICO"			=>"P_CDSERVFILI",
			  "DTINICIAL"			=>"P_DTINICIAL",
			  "DTFINAL"				=>"P_DTFINAL"
			),
		),
	);
	public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
		$row = $request->getRow();
		$row['DTINICIAL'] = $row['DTCARDAPIO']['start'];
		$row['DTFINAL'] = $row['DTCARDAPIO']['end'];
		$this->getServicos($request, $response);
	}

	protected function getServicos($request, $response){
		$row = $request->getRow();
		if($row['NMSERVICO']=="T"){
			$row['NMSERVICO'] =array();
			$conditions = array(
				array(
    			'columnName' => 'CDFILIAL',
    			'operator' => '=',
    			'value' => $row['CDFILIAL']
    		),
        array(
    			'columnName' => 'CDGRUPSERV',
    			'operator' => '=',
    			'value' => ($row['NMGRUPSERV']=="T") ? $row['NMGRUPSERV'] : join("_" , $row['NMGRUPSERV'])
    		)
    	);
			$this->parameterBagColumns = array("CDFILIAL", "CDGRUPSERV", "NRORG");
    	$filterCriteria = new FilterCriteria('pla04800_servico', $conditions);
    	$filterCriteria = $this->crudService->getFilterCriteriaWithNrOrg($filterCriteria);
      $newFilterCriteria = $this->crudService->populateParameterBag($filterCriteria, $this->parameterBagColumns);
      $dataSet = $this->dataSourceManager->findBy($newFilterCriteria);
      foreach($dataSet->getRows() as $servico){
      	array_push($row['NMSERVICO'], $servico['CDSERVFILI']);
      }
		}
		$row['NMSERVICO'] = join("_", $row['NMSERVICO']);
	}


}